source: common/func_validate_configs.sh@ 0510381

experimental
Last change on this file since 0510381 was 42e1b38, checked in by George Boudreau <georgeb@…>, 18 years ago

Add code for user defined scripts. User scripts added at the end of the final build (LFS only)

  • Property mode set to 100644
File size: 8.6 KB
Line 
1# $Id$
2
3declare -r dotSTR=".................."
4
5
6#----------------------------#
7validate_config() { # Are the config values sane (within reason)
8#----------------------------#
9: <<inline_doc
10 Validates the configuration parameters. The global var PROGNAME selects the
11 parameter list.
12
13 input vars: none
14 externals: color constants
15 PROGNAME (lfs,clfs,hlfs)
16 modifies: none
17 returns: nothing
18 on error: write text to console and dies
19 on success: write text to console and returns
20inline_doc
21
22 # First internal variables, then the ones that change the book's flavour, and lastly system configuration variables
23 local -r hlfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE MODEL GRSECURITY_HOST TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG GETKERNEL PAGE TIMEZONE LANG LC_ALL LUSER LGROUP BLFS_TOOL"
24 local -r clfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE METHOD ARCH TARGET TARGET32 TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB BOOT_CONFIG CONFIG GETKERNEL VIMLANG PAGE TIMEZONE LANG LUSER LGROUP BLFS_TOOL"
25 local -r clfs2_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE ARCH TARGET OPTIMIZE REPORT STRIP FSTAB CONFIG GETKERNEL VIMLANG PAGE TIMEZONE LANG LUSER LGROUP BLFS_TOOL"
26 local -r lfs_PARAM_LIST="BOOK BUILDDIR SRC_ARCHIVE GETPKG RUNMAKE TEST BOMB_TEST OPTIMIZE REPORT COMPARE RUN_ICA RUN_FARCE ITERATIONS STRIP FSTAB CONFIG GETKERNEL VIMLANG PAGE TIMEZONE LANG LUSER LGROUP BLFS_TOOL CUSTOM_TOOLS"
27 local -r blfs_PARAM_LIST="BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR"
28
29 local -r blfs_tool_PARAM_LIST="BLFS_BRANCH_ID BLFS_ROOT BLFS_XML TRACKING_DIR DEP_LIBXML DEP_LIBXSLT DEP_TIDY DEP_UNZIP DEP_DBXML DEP_DBXSL DEP_LINKS DEP_SUDO DEP_WGET DEP_SVN DEP_GPM"
30
31 local -r ERROR_MSG_pt1='The variable \"${L_arrow}${config_param}${R_arrow}\" value ${L_arrow}${BOLD}${!config_param}${R_arrow} is invalid,'
32 local -r ERROR_MSG_pt2='rerun make and fix your configuration settings${OFF}'
33 local -r PARAM_VALS='${config_param}${dotSTR:${#config_param}} ${L_arrow}${BOLD}${!config_param}${OFF}${R_arrow}'
34
35 local PARAM_LIST=
36 local config_param
37 local validation_str
38 local save_param
39
40 write_error_and_die() {
41 echo -e "\n${DD_BORDER}"
42 echo -e "`eval echo ${ERROR_MSG_pt1}`" >&2
43 echo -e "`eval echo ${ERROR_MSG_pt2}`" >&2
44 echo -e "${DD_BORDER}\n"
45 exit 1
46 }
47
48 validate_file() {
49 # For parameters ending with a '+' failure causes a warning message only
50 echo -n "`eval echo $PARAM_VALS`"
51 while test $# -gt 0 ; do
52 case $1 in
53 # Failures caused program exit
54 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO file name given" && write_error_and_die ;;
55 "-e") [[ ! -e "${!config_param}" ]] && echo "${tab_}<-- file does not exist" && write_error_and_die ;;
56 "-s") [[ ! -s "${!config_param}" ]] && echo "${tab_}<-- file has zero bytes" && write_error_and_die ;;
57 "-r") [[ ! -r "${!config_param}" ]] && echo "${tab_}<-- no read permission " && write_error_and_die ;;
58 "-w") [[ ! -w "${!config_param}" ]] && echo "${tab_}<-- no write permission" && write_error_and_die ;;
59 "-x") [[ ! -x "${!config_param}" ]] && echo "${tab_}<-- file cannot be executed" && write_error_and_die ;;
60 # Warning messages only
61 "-z+") [[ -z "${!config_param}" ]] && echo && return ;;
62 esac
63 shift 1
64 done
65 echo
66 }
67
68 validate_dir() {
69 # For parameters ending with a '+' failure causes a warning message only
70 echo -n "`eval echo $PARAM_VALS`"
71 while test $# -gt 0 ; do
72 case $1 in
73 "-z") [[ -z "${!config_param}" ]] && echo "${tab_}NO directory name given" && write_error_and_die ;;
74 "-d") [[ ! -d "${!config_param}" ]] && echo "${tab_}This is NOT a directory" && write_error_and_die ;;
75 "-w") if [[ ! -w "${!config_param}" ]]; then
76 echo "${nl_}${DD_BORDER}"
77 echo "${tab_}${RED}You do not have ${L_arrow}write${R_arrow}${RED} access to the directory${OFF}"
78 echo "${tab_}${BOLD}${!config_param}${OFF}"
79 echo "${DD_BORDER}${nl_}"
80 exit 1
81 fi ;;
82 # Warnings only
83 "-w+") if [[ ! -w "${!config_param}" ]]; then
84 echo "${nl_}${DD_BORDER}"
85 echo "${tab_}WARNING-- You do not have ${L_arrow}write${R_arrow} access to the directory${OFF}"
86 echo "${tab_} -- ${BOLD}${!config_param}${OFF}"
87 echo "${DD_BORDER}"
88 fi ;;
89 "-z+") [[ -z "${!config_param}" ]] && echo "${tab_}<-- NO directory name given" && return
90 esac
91 shift 1
92 done
93 echo
94 }
95
96 set +e
97 PARAM_GROUP=${PROGNAME}_PARAM_LIST
98 for config_param in ${!PARAM_GROUP}; do
99 case $config_param in
100 # Allways display this, if found in ${PROGNAME}_PARAM_LIST
101 GETPKG | \
102 RUNMAKE | \
103 TEST | \
104 OPTIMIZE | \
105 STRIP | \
106 VIMLANG | \
107 MODEL | \
108 METHOD | \
109 ARCH | \
110 TARGET | \
111 GRSECURITY_HOST | \
112 BLFS_TOOL | \
113 CUSTOM_TOOLS | \
114 TIMEZONE | \
115 PAGE) echo -e "`eval echo $PARAM_VALS`" ;;
116
117 # Envvars that depend on other settings to be displayed
118 GETKERNEL ) if [[ -z "$CONFIG" ]] && [[ -z "$BOOT_CONFIG" ]] ; then
119 [[ "$GETPKG" = "y" ]] && echo -e "`eval echo $PARAM_VALS`"
120 fi ;;
121 COMPARE) [[ ! "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
122 RUN_ICA) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
123 RUN_FARCE) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
124 ITERATIONS) [[ "$COMPARE" = "y" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
125 BOMB_TEST) [[ ! "$TEST" = "0" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
126 TARGET32) [[ -n "${TARGET32}" ]] && echo -e "`eval echo $PARAM_VALS`" ;;
127
128 # Envars that requires some validation
129 LUSER) echo -e "`eval echo $PARAM_VALS`"
130 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
131 ;;
132 LGROUP) echo -e "`eval echo $PARAM_VALS`"
133 [[ "${!config_param}" = "**EDIT ME**" ]] && write_error_and_die
134 ;;
135 REPORT) echo -e "`eval echo $PARAM_VALS`"
136 if [[ "${!config_param}" = "y" ]]; then
137 if [[ `type -p bc` ]]; then
138 continue
139 else
140 echo -e " ${BOLD}The bc binary was not found${OFF}"
141 echo -e " The SBU and disk usage report creation will be skiped"
142 REPORT=n
143 continue
144 fi
145 fi ;;
146
147 # BOOK validation. Very ugly, need be fixed
148 BOOK) if [[ "${WORKING_COPY}" = "y" ]] ; then
149 validate_dir -z -d
150 else
151 echo -e "`eval echo $PARAM_VALS`"
152 fi ;;
153
154 # Validate directories, testable states:
155 # fatal -z -d -w,
156 # warning -z+ -w+
157 SRC_ARCHIVE) [[ "$GETPKG" = "y" ]] && validate_dir -z+ -d -w+ ;;
158 # The build directory/partition MUST exist and be writable by the user
159 BUILDDIR) validate_dir -z -d -w
160 [[ "xx x/x" =~ "x${!config_param}x" ]] && write_error_and_die ;;
161
162 # Validate files, testable states:
163 # fatal -z -e -s -w -x -r,
164 # warning -z+
165 FSTAB) validate_file -z+ -e -s ;;
166 CONFIG) validate_file -z+ -e -s ;;
167 BOOT_CONFIG) [[ "${METHOD}" = "boot" ]] && validate_file -z -e -s ;;
168
169 # Treatment of 'special' parameters
170 LANG | \
171 LC_ALL) # See it the locale values exist on this machine
172 echo -n "`eval echo $PARAM_VALS`"
173 [[ -z "${!config_param}" ]] &&
174 echo " -- Variable $config_param cannot be empty!" &&
175 write_error_and_die
176 echo
177 ;;
178
179 # BLFS params.
180 BRANCH_ID | BLFS_ROOT | BLFS_XML ) echo "`eval echo $PARAM_VALS`" ;;
181 TRACKING_DIR ) validate_dir -z -d -w ;;
182
183 esac
184 done
185
186 if [[ "${BLFS_TOOL}" = "y" ]] ; then
187 echo "${nl_} ${BLUE}blfs-tool settings${OFF}"
188 for config_param in ${blfs_tool_PARAM_LIST}; do
189 echo -e "`eval echo $PARAM_VALS`"
190 done
191 fi
192
193 set -e
194 echo "${nl_}***${BOLD}${GREEN} ${PARAM_GROUP%%_*T} config parameters look good${OFF} ***${nl_}"
195}
Note: See TracBrowser for help on using the repository browser.